      SUBROUTINE INTEGR(JDIM,KDIM,Q,S,PRESS,SNDSP,SLOPE,X,Y,XY,XYJ,
     +                    XIT,ETT,DS,DELTQN,
     +                    UU,VV,CCX,CCY,COEF2X,COEF2Y,COEF4X,COEF4Y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  MAIN INTEGRATION CALLS
C
      PARAMETER (MAXJ=165, MAXK=48, MAXJK=MAXJ*MAXK  )
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM*KDIM*4)
      DIMENSION PRESS(JDIM*KDIM),SNDSP(JDIM*KDIM)
      DIMENSION S(JDIM*KDIM*4),XY(JDIM*KDIM*4),XYJ(JDIM*KDIM)
      DIMENSION XIT(JDIM*KDIM),ETT(JDIM*KDIM),DS(JDIM*KDIM)
      DIMENSION X(JDIM*KDIM),Y(JDIM*KDIM),SLOPE(JDIM)
C
      DIMENSION DELTQN(JDIM*KDIM*4)
      DIMENSION UU(JDIM*KDIM),CCX(JDIM*KDIM)
      DIMENSION VV(JDIM*KDIM),CCY(JDIM*KDIM)
      DIMENSION COEF2X(JDIM*KDIM),COEF2Y(JDIM*KDIM)
      DIMENSION COEF4X(JDIM*KDIM),COEF4Y(JDIM*KDIM)
C
      COMMON/WORK/WORK1(MAXJK,10)
C
C
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C <<<                    EXPLICIT OPERATORS                        >>>
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C
C*********************************************************************
C***    0. UPDATE PRESSURE AND SOUND SPEED                         ***
C*********************************************************************
C
        CALL CALCPS(JDIM,KDIM,Q,PRESS,SNDSP)
C
C*********************************************************************
C***   1. EXPLICIT BOUNDARY CONDITIONS                             ***
C*********************************************************************
C
            CALL BC(JDIM,KDIM,Q,PRESS,SNDSP,XY,XIT,ETT,XYJ,X,Y,SLOPE)
C
C*********************************************************************
C***   2.  EXPLICIT RHS                                            ***
C*********************************************************************
C---------------------------------------------------------------------
C---      EXPLICIT OPERATOR IN XI                                  ---
C---------------------------------------------------------------------
       CALL RHSX(JDIM,KDIM,Q,S,PRESS,XY,XYJ,XIT,WORK1)
C
C---------------------------------------------------------------------
C        EXPLICIT OPERATORS IN ETA
C---------------------------------------------------------------------
       CALL RHSY(JDIM,KDIM,Q,S,PRESS,XY,XYJ,ETT,WORK1)
C
C
C---------------------------------------------------------------------
C---            3-A-1. CALCULATE EIGENVALUES FOR XI AND ETA          ---
C---------------------------------------------------------------------
C
                IX = 1
                IY = 2
                CALL EIGVAL(IX,IY,JDIM,KDIM,Q,PRESS,SNDSP,XYJ,
     *                                              XY,XIT,UU,CCX)
                IX = 3
                IY = 4
                CALL EIGVAL(IX,IY,JDIM,KDIM,Q,PRESS,SNDSP,XYJ,
     *                                               XY,ETT,VV,CCY)
C
C 
C---------------------------------------------------------------------
C---            3-A-2. FORM SPECTRAL RADII FOR DISSIPATION MODEL ---
C---------------------------------------------------------------------
C
              CALL SPECT(JDIM,KDIM,UU,VV,CCX,CCY,XYJ,XY,COEF4X,COEF4Y)
C
C*********************************************************************
C***   3-B. DISSIPATION TERMS                                      ***
C*********************************************************************
C
C---------------------------------------------------------------------
C---           3-B-1-A. FORM PRESSURE COEFFICIENTS                ---
C---------------------------------------------------------------------
                IXY = 1
                CALL GRADCO(IXY,JDIM,KDIM,PRESS,XYJ,COEF2X,WORK1)
                IXY = 2
                CALL GRADCO(IXY,JDIM,KDIM,PRESS,XYJ,COEF2Y,WORK1)
C
C---------------------------------------------------------------------
C---            3-B-1-B. ARTIFICIAL DISSIPATION COEFFICIENTS       ---
C---------------------------------------------------------------------
C
                CALL COEF24(JDIM,KDIM,COEF2X,COEF4X,COEF2Y,COEF4Y,
     +                      WORK1(1,1),WORK1(1,2))
C
C---------------------------------------------------------------------
C---      3-B-2. ARTIFICIAL DISSIPATION                            ---
C---------------------------------------------------------------------
C
          CALL FILERX(JDIM,KDIM,Q,S,XYJ,COEF2X,COEF4X,WORK1)
          CALL FILERY(JDIM,KDIM,Q,S,XYJ,COEF2Y,COEF4Y,WORK1)
C
C---------------------------------------------------------------------
C
C*********************************************************************
C       4.  COMPUTE RESIDUAL AND SCALE BY VARIABLE DT
C*********************************************************************
C---------------------------------------------------------------------
C---      4-A. COMPUTE L2 AND MAX NORMS OF RESIDUAL                ---
C---------------------------------------------------------------------
C
C    DENSITY RESIDUAL
C
C
C
          NRES = 1
          CALL RESIL2(JDIM,KDIM,S,NRES)
C*********************************************************************
C*********************************************************************
C
C---------------------------------------------------------------------
C---      4-B. SCALE WITH VARIABLE DT                              ---
C---------------------------------------------------------------------
C
          CALL SCALDT(JDIM,KDIM,S,DS)
C
C
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C<<<                     IMPLICIT OPERATORS                        >>>
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C---------------------------------------------------------------------
C    5. SCALAR PENTADIAGONAL ALGORITHM
C---------------------------------------------------------------------
C
C---------------------------------------------------------------------
C---      5-A. INTEGRATION   XI - ETA ORDER                        ---
C---------------------------------------------------------------------
C
C.....................................................................
C...                      -1                                       ...
C...           5-A-1.    T   S    EIGENVECTOR INVERSE MULTIPLY BY RHS
C...                      XI       CALL WITH 1,2 FOR XI METRICS    ...
C.....................................................................
C
              IX = 1
              IY = 2
              CALL TKINV(JDIM,KDIM,Q,SNDSP,S,XYJ,XY,IX,IY)
C
C.....................................................................
C...         5-A-2.    XI DIAGONAL INVERSIONS                      ...
C.....................................................................
C
             CALL STEPFX(JDIM,KDIM,Q,S,PRESS,SNDSP,XY,XYJ,DS,
     *                                    COEF2X,COEF4X,UU,CCX,WORK1)
C
C.....................................................................
C...              N INVERSE MULTIPLY BETWEEN DIAGONAL OPERATORS    ...
C.....................................................................
C
                  IXX = 1
                  IXY = 2
                  IYX = 3
                  IYY = 4
                  CALL NINVER(JDIM,KDIM,S,XY,IXX,IXY,IYX,IYY)
C.....................................................................
C...              ETA DIAGONAL INTEGRATION                         ...
C.....................................................................
C
                  CALL STEPFY(JDIM,KDIM,Q,S,PRESS,SNDSP,
     *                            XY,XYJ,DS,COEF2Y,COEF4Y,VV,CCY,WORK1)
C.....................................................................
C...              T    S  MATRIX MULTIPLY TO CLOSE DIAGONALIZATION ...
C...               ETA     3, 4  FOR ETA METRICS                   ...
C.....................................................................
C 
                  IX = 3
                  IY = 4
                  CALL TK(JDIM,KDIM,Q,SNDSP,S,XYJ,XY,IX,IY)
C
C.....................................................................
C---------------------------------------------------------------------
C---    END 5-A.                                                   ---
C---------------------------------------------------------------------
C*********************************************************************
C***   END 5.                                                      ***
C*********************************************************************
C
C*********************************************************************
C
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C<<<                    FINISH INTEGRATION                         >>>
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C*********************************************************************
C***    7. UPDATE                                                  ***
C*********************************************************************
C
        CALL UPDATE(JDIM,KDIM,Q,S,DELTQN)
C
C
                     RETURN
                     END
